MESSAGE "macro file included!"

; Load Address macro

la MACRO reg,addr
	lui	reg,addr >> 16
	ori	reg,reg,(addr & 0FFFFh)
la ENDM

; Load Immidiate macro

li MACRO reg,imm
  lui	reg,imm >> 16
  ori	reg,reg,(imm & 0FFFFh)
li ENDM

; Load Immidiate Double (64bit) macro

lid MACRO reg,imm
	lui	reg,imm >> 48
	ori	reg,reg,(imm >> 32)&0FFFFh
	dsll	reg,reg,16
	ori	reg,reg,(imm >> 16)&0FFFFh
	dsll	reg,reg,16
	ori	reg,reg,(imm&0FFFFh)
lid ENDM

; Dump register and print to screen macro

dumpreg MACRO reg

	add	t0,zero,reg
	jal	@reg2ascii
	nop
	la	a3,@reg_buffer
	jal	@printf
	nop
dumpreg ENDM

; Set font front color

ffcolor MACRO col
	la	a0,@font_fcolor
	li	t0,col
	sw	t0,0(a0)
ffcolor	ENDM

; Set font background color

fbcolor MACRO col
	la	a0,@font_bcolor
	li	t0,col
	sw	t0,0(a0)
fbcolor	ENDM

; Set screen position for printf

locate	MACRO x,y
	la	a0,@xy_pos
	addi	t0,zero,x	; x pos
	sh	t0,0(a0)
	addi	t0,zero,y	; y pos
	sh	t0,2(a0)
locate	ENDM

; Print to screen

print	MACRO	addr
	la	a3,addr
	jal	@printf
	nop
print	ENDM